var
  a: array[1..210,1..210] of byte;
  u,v: array[1..16] of integer;
  s: array[1..16] of byte;
  n,m,k: integer;
  i,j,v1,v2: integer;
  F: text;
  names,name1,name2,ans: string;

function StrongConnected: Boolean;
var
  cntA,cntB,i: integer;
  visited: array[1..210] of byte;

Procedure DFSA(u: integer);
var
  v: integer;
begin
  visited[u]:=1;
  cntA:=cntA+1;
  for v:=1 to n do
    if (visited[v]=0) and  (a[u,v]=1) then
      DFSA(v);
end;

Procedure DFSB(u: integer);
var
  v: integer;
begin
  visited[u]:=1;
  cntB:=cntB+1;
  for v:=1 to n do
    if (visited[v]=0) and  (a[v,u]=1) then
      DFSB(v);
end;

begin
  for i:=1 to n do
    visited[i]:=0;
  cntA:=0;
  DFSA(1);
  for i:=1 to n do
    visited[i]:=0;
  cntB:=0;
  DFSB(1);
  if (cntA=n) and (cntB=n) then
    StrongConnected:=true
  else
    StrongConnected:=false;
end;

begin
  readln(names);
  while names[1]=' ' do
    Delete(names,1,1);
  while names[Length(names)]=' ' do
    Delete(names,Length(names),1);
  while Pos('  ',names)>0 do
    Delete(names,Pos('  ',names),1);
  name1:=Copy(names,1,Pos(' ',names)-1);
  Delete(names,1,Pos(' ',names));
  name2:=names;
  assign(F,name1);
  reset(F);
  readln(F,n,m,k);
  for i:=1 to n do
    for j:=1 to n do
      a[i,j]:=0;
  for i:=1 to m-k do
    begin
      readln(F,v1,v2);
      Inc(a[v1,v2]);
    end;
  for i:=1 to k do
    begin
      readln(F,u[i],v[i]);
      Inc(a[u[i],v[i]]);
    end;
  close(F);

  assign(F,name2);
  reset(F);
  readln(F,ans);
  close(F);

  if ans='No way' then
    begin
      for i:=1 to k do
        s[i]:=0;
      repeat
        for i:=1 to k do
          if s[i]=0 then
            begin
              a[u[i],v[i]]:=1;
              a[v[i],u[i]]:=0;
            end
          else
            begin
              a[u[i],v[i]]:=0;
              a[v[i],u[i]]:=1;
            end;

        if StrongConnected then
          begin
            write('N');
            exit;
          end;

       i:=k;
       while (i>0) and (s[i]=1) do
         begin
           s[i]:=0;
           i:=i-1;
         end;
       if i>0 then s[i]:=1;
      until i=0;

      write('Y');
      exit;
    end;


 if Length(ans)<k then
    begin
      write('N');
      exit;
    end;
  for i:=1 to k do
    if not (ans[i] in ['0','1']) then
      begin
        write('N');
        exit;
      end;

  for i:=1 to k do
    s[i]:=ord(ans[i])-48;

    for i:=1 to k do
      if s[i]=0 then
        begin
          a[u[i],v[i]]:=1;
          a[v[i],u[i]]:=0;
        end
      else
        begin
          a[u[i],v[i]]:=0;
          a[v[i],u[i]]:=1;
        end;

    if StrongConnected then
      writeln('Y')
    else
      writeln('N');
end.


